"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const browserSync = require("browser-sync");
const chokidar = require("chokidar");
const path = require("path");
const copy = require("recursive-copy");
const docs_1 = require("../../base/docs");
const conf_1 = require("../../services/conf");
const track_1 = require("../../services/track");
const { join } = path;
class DocsServe extends docs_1.default {
    async run() {
        if (conf_1.default.rdType === conf_1.default.RdTypes.Container) {
            // await doc.generateChangelog()
            // await doc.generateCheatSheet()
        }
        this.watchFiles();
        browserSync({
            server: conf_1.default.docsPagesDir,
            ui: {
                port: 4040,
            },
            watch: true,
            open: true,
        });
    }
    watchFiles() {
        const watcher = chokidar.watch(conf_1.default.docsDir, {
            interval: 300,
        });
        const handler = async () => {
            await copy(conf_1.default.docsDir, join(conf_1.default.docsPagesDir), this.options);
        };
        watcher
            .on('add', handler)
            .on('change', handler)
            .on('unlink', handler);
    }
}
DocsServe.flags = Object.assign({}, docs_1.default.flags);
DocsServe.examples = [
    '$ rde docs:serve',
];
tslib_1.__decorate([
    track_1.TError({ conf: conf_1.default }),
    track_1.TStart
], DocsServe.prototype, "run", null);
tslib_1.__decorate([
    track_1.TError({ conf: conf_1.default }),
    track_1.TStart
], DocsServe.prototype, "watchFiles", null);
exports.default = DocsServe;
